﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;

namespace XamGridTester
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
            this.DataContext = new GridModel();
        }

        private void btnAddCol_Click(object sender, RoutedEventArgs e)
        {
            GridModel gm = this.DataContext as GridModel;
            ObservableCollection<GridRow> tds = gm.GridSource;

            for (int i = 0; i < tds.Count; i++)
            {
                //add a new cell to each of exisitng rows - simulate adding new column.
                tds[i].Cells.Add("R" + i.ToString() + "C" + tds[i].Cells.Count.ToString());

            }

            //-----------------
            string colNum = templateXamGrid.FieldLayouts[0].Fields.Count.ToString();
            UnboundField uf = new UnboundField();
            uf.Name = "Cells[" + colNum + "]";
            uf.Label = "Col " + colNum;
            PropertyPath p = new PropertyPath("Cells[" + colNum + "]");
            uf.BindingPath = p;

            FieldSettings fs = new FieldSettings();
            //fs.AllowEdit = false;
            fs.AllowGroupBy = true;
            uf.Settings = fs;

            templateXamGrid.FieldLayouts[0].Fields.Add(uf);
        }

        private void btnAddRow_Click(object sender, RoutedEventArgs e)
        {
            GridModel gm = this.DataContext as GridModel;
            ObservableCollection<GridRow> tds = gm.GridSource;
            GridRow gr = new GridRow();

            for (int i = 0; i < templateXamGrid.FieldLayouts[0].Fields.Count; i++)
            {
               gr.Cells.Add("R" + tds.Count.ToString() + "C" + i.ToString());
            }

            tds.Add(gr);
        }
    }
}
